#!/opt/php5/bin/php
<?php
$options = getopt("i:o:d:");

function usage()
{
	echo "{$GLOBALS['argv'][0]} -i <include_dump> [-o <output_file>] [-d docroot]\n";
	exit(1);
}

if(!isset($options['o'])) $ofile = "inclued.out.dot";	
else $ofile = $options['0'];

if(!isset($options['i'])) usage();
else $ifile = $options['i'];

if(!isset($options['d'])) $docroot = "";
else $docroot = $options['d'];

$data = unserialize(file_get_contents($ifile));

if(!$data) 
{
	echo "Could not deserialize data dump\n";
	exit(1);
}

function dump_include($fp, $inc)
{
	global $docroot;

	$style = isset($inc['duplicate']) ? "dashed" : "solid";

	$short_fromfile = str_replace($docroot, '', $inc['fromfile']);
	$short_opened_path = str_replace($docroot, '', $inc['opened_path']);

	$content = <<<EOF

	"{$inc['fromfile']}" [label="{$short_fromfile}"];
	"{$inc['opened_path']}" [label="{$short_opened_path}"];

	"{$inc['fromfile']}" -> "{$inc['opened_path']}" [label = "{$inc['operation']}", style="{$style}"];

EOF;

	fwrite($fp, $content);
}

$fp = fopen($ofile, "wb");

$content = 	<<<EOF
digraph phpdeps {
	size="6.6";
	node [shape = ellipse];
	node [color="#add960", style=filled];
	graph [bgcolor="#f7f7f7"];

EOF;

fwrite($fp, $content);

foreach($data["includes"] as $k => $v) dump_include($fp, $v);

fwrite($fp, "}");

echo "To generate images: dot -Tpng -o inclued.png $ofile\n";

?>

/* $Id: gengraph.php,v 1.1 2007/08/07 21:40:50 gopalv Exp $ */
